#define USER_EXCEPTION
//#define SOFT_BREAK
//#define INT_EXCEPTION

#define  LED_port  *((volatile unsigned int *)0x8a000020)

int led_val;
int ITER1 = 100000;
int ITER2 = 100000;

void user_vector_exception_handler(){

    if(led_val == 0xF){
      led_val = 0;
    }
    else
      led_val ++;

    LED_port = led_val;
}

void external_int_handler(){
    LED_port = 0xE;
}

void break_exception_handler(){
    LED_port = 0x6;
}

int main(){
  int i, j;

  LED_port = 0xA;

  led_val = 0;
  for(j=0;j<10;j++){
    for(i=0;i<ITER1;i++){}
#ifdef USER_EXCEPTION
    asm volatile ("bralid r15, 0x8");
    asm volatile ("nop");
#else
#ifdef SOFT_BREAK
    asm volatile ("brki r16, 0x18");
    asm volatile ("nop");    
#else
#ifdef INT_EXCEPTION
    asm volatile ("bralid r14, 0x10");
    asm volatile ("nop");
#else
    if(led_val == 0xF){
      led_val = 0;
    }
    else
      led_val ++;
    LED_port = led_val;
#endif
#endif
#endif
    for(i=0;i<ITER2;i++){}
    LED_port = 0;
  }

  return 0;
}

