	.data

	.extern	main
	.extern int_handler
#====================================
#      Exception Vectors
#====================================
	.org	0x100
	# System reset
__reset_vector:				#$B"+%j%;%C%H%Y%/%?(B
	b	__startup
	.org	0x500
	# External Interrupt
	b	__global_exception_handler
	.org	0x900
	# Decrementer
.ifndef ROM_TARGET
	lwz	r0, 8(r1)
	mtlr	r0
	lwz	r0, 4(r1)
	stwu	r1, 0(r1)
.endif /* !ROM_TARGET */
	rfi
	
# GDB$B$G$O$3$3$+$i<B9T$,;O$^$j$^$9!#(B	
	.text
	.global	__startup 
__startup:
.ifdef ROM_TARGET		#$B"-(B(A) ROM$B2=;~$N$_;HMQ$5$l$k!#$3$NItJ,$O%W%m%;%C%5$N5/F0D>8e$K<B9T$5$l$k$Y$-=i4|2=A`:n$,5-=R$5$l$k!#(B
	/* data$B%;%/%7%g%s$r(BROM->RAM$B%3%T!<(B */	#$B"-(BROM$B$KJ]B8$5$l$F$$$k=i4|2=:Q$_$N(Bdata$B%;%/%7%g%s$r(BRAM$BNN0h$K%3%T!<$9$k!#(B
	lis	r1, _sdata_loadaddr@ha
	ori	r1, r1, _sdata_loadaddr@l
	lis	r2, _sdata@ha
	ori	r2, r2, _sdata@l
	lis	r3, _edata@ha
	ori	r3, r3, _edata@l
__copy_loop:
	lbz	r4, 0(r1)
	stb	r4, 0(r1)
	addi	r1, r1, 1
	addi	r2, r2, 1
	sub	r4, r3, r2
	cmpwi	cr7, r4, 0
	bgt	r4, __copy_loop
.endif /* ROM_TARGET */	#$B",(B(A)
	
	# $B%9%?%C%/$r@_Dj$9$k(B
	lis	r1, _stack_base@ha	#$B"+%f!<%6%W%m%0%i%`B&$G%9%?%C%/$r@_Dj(B
	ori	r1, r1, _stack_base@l

.ifndef ROM_TARGET		#$B"-(B(B)$B%f!<%6%W%m%0%i%`%G%P%C%0;~$N$_<B9T$9$k!%(BROM$B2=;~$O:o=|$5$l$k!%(B
	/* $B%9%?%C%/$K%l%8%9%?$rB`Hr$9$k(B*/
	stwu	r1, -140(r1)
	stw	r0, 4(r1)
	stw	r2, 8(r1)
	stw	r3, 12(r1)
	stw	r4, 16(r1)
	stw	r5, 20(r1)
	stw	r6, 24(r1)
	stw	r7, 28(r1)
	stw	r8, 32(r1)
	stw	r9, 36(r1)
	stw	r10, 40(r1)
	stw	r11, 44(r1)
	stw	r12, 48(r1)
	stw	r13, 52(r1)
	stw	r14, 56(r1)
	stw	r15, 60(r1)
	stw	r16, 64(r1)
	stw	r17, 68(r1)
	stw	r18, 72(r1)
	stw	r19, 76(r1)
	stw	r20, 80(r1)
	stw	r21, 84(r1)
	stw	r22, 88(r1)
	stw	r23, 92(r1)
	stw	r24, 96(r1)
	stw	r25, 100(r1)
	stw	r26, 104(r1)
	stw	r27, 108(r1)
	stw	r28, 112(r1)
	stw	r29, 116(r1)
	stw	r30, 120(r1)
	stw	r31, 124(r1)
	mflr	r0
	stw	r0, 128(r1)
	mfcr	r0
	stw	r0, 132(r1)
	
	# $B%f!<%6Nc30%Y%/%?$N%Y!<%9%"%I%l%9$r@_Dj$7$^$9!#(B
	lis	r0, _user_exception_vector_addr@ha	#$B"-FbB"(BRAM$B$N:G>e0L$N(B4$B%P%$%H$K!"BeBX%Y%/%?$N%"%I%l%9$r3JG<$9$k(B
	ori	r0, r0, _user_exception_vector_addr@l
	lis	r2, _user_vector_base_addr@ha
	ori	r2, r2, _user_vector_base_addr@l
	stw	r2, 0(r0)		#$B",(B

	bl	main			#$B"+(Bmain()$B4X?t$K%8%c%s%W(B

	lwz	r0, 4(r1)		#$B"-B`Hr$7$?HFMQ%l%8%9%?$NFbMF$rI|5"(B
	lwz	r2, 8(r1)
	lwz	r3, 12(r1)
	lwz	r4, 16(r1)
	lwz	r5, 20(r1)
	lwz	r6, 24(r1)
	lwz	r7, 28(r1)
	lwz	r8, 32(r1)
	lwz	r9, 36(r1)
	lwz	r10, 40(r1)
	lwz	r11, 44(r1)
	lwz	r12, 48(r1)
	lwz	r13, 52(r1)
	lwz	r14, 56(r1)
	lwz	r15, 60(r1)
	lwz	r16, 64(r1)
	lwz	r17, 68(r1)
	lwz	r18, 72(r1)
	lwz	r19, 76(r1)
	lwz	r20, 80(r1)
	lwz	r21, 84(r1)
	lwz	r22, 88(r1)
	lwz	r23, 92(r1)
	lwz	r24, 96(r1)
	lwz	r25, 100(r1)
	lwz	r26, 104(r1)
	lwz	r27, 108(r1)
	lwz	r28, 112(r1)
	lwz	r29, 116(r1)
	lwz	r30, 120(r1)
	lwz	r31, 124(r1)
	lwz	r0, 128(r1)
	mtlr	r0
	lwz	r0, 132(r1)
	mtcr	r0
	
	lwz	r1, 0(r1)

	blr				#$B%9%?%V$GJ]B8$5$l$?(BLR$B$NFbMF!"$D$^$j!"%9%?%V$G%@%&%s%m!<%I%W%m%0%i%`$,8F$P$l$?%"%I%l%9$K%j%?!<%s$9$k!#(B
.endif /* !ROM_TARGET */		#$B",(B(B)

.ifdef ROM_TARGET			#$B"-(B(C)$B%f!<%6%W%m%0%i%`(BROM$B2=;~$N$_<B9T$9$k!%%G%P%C%0;~$O:o=|$5$l$k!%(B

	bl	main			#$B"+(Bmain()$B4X?t$KLa$jHVCO$r(BLR$B$KJ]B8$7$FJ,4t$9$k!#(B
.endif /* ROM_TARGET */
	
_loop_here:				#$B"+(BROM$B2=;~$K8m$C$F$3$3$^$GMh$?$H$-$KL58B%k!<%W$K4Y$i$;$k$?$a$N%;%$%U%F%#%M%C%H!#(B
	b	_loop_here

__global_exception_handler:		#$B"+Nc30%Y%/%?$+$i8F$P$l$k%0%m!<%P%k$NNc30%O%s%I%i!#$3$N4X?t$G$I$NNc30$,H/@8$7$F$$$k$+$rH=Dj$9$k!#(B
.ifndef ROM_TARGET			#$B"-(B(D)ROM$B2=;~$O:o=|$5$l$k!#(B
	lwz	r0, 8(r1)		#$B"-%9%?%V$NNc30%O%s%I%i$G%9%?%C%/%]%$%s%?$,?J$s$G$$$k$N$G$=$l$rLa$9(B
	mtlr	r0
	lwz	r0, 4(r1)
	stwu	r1, 0(r1)
.endif	/* !ROM_TARGET */		#$B",(B(C)
	
	/* $B%9%?%C%/$K%l%8%9%?$rB`Hr$9$k(B*/
	stwu	r1, -140(r1)		#$B"-%9%?%C%/$K%l%8%9%?$rB`Hr$9$k!#(B
	stw	r0, 4(r1)
	stw	r2, 8(r1)
	stw	r3, 12(r1)
	stw	r4, 16(r1)
	stw	r5, 20(r1)
	stw	r6, 24(r1)
	stw	r7, 28(r1)
	stw	r8, 32(r1)
	stw	r9, 36(r1)
	stw	r10, 40(r1)
	stw	r11, 44(r1)
	stw	r12, 48(r1)
	stw	r13, 52(r1)
	stw	r14, 56(r1)
	stw	r15, 60(r1)
	stw	r16, 64(r1)
	stw	r17, 68(r1)
	stw	r18, 72(r1)
	stw	r19, 76(r1)
	stw	r20, 80(r1)
	stw	r21, 84(r1)
	stw	r22, 88(r1)
	stw	r23, 92(r1)
	stw	r24, 96(r1)
	stw	r25, 100(r1)
	stw	r26, 104(r1)
	stw	r27, 108(r1)
	stw	r28, 112(r1)
	stw	r29, 116(r1)
	stw	r30, 120(r1)
	stw	r31, 124(r1)
	mflr	r0
	stw	r0, 128(r1)
	mfcr	r0
	stw	r0, 132(r1)		#$B",(B

	bl	__global_exception_func

	lwz	r0, 4(r1)		#$B"-%l%8%9%?$r%9%?%C%/$+$iI|5"!#(B
	lwz	r2, 8(r1)
	lwz	r3, 12(r1)
	lwz	r4, 16(r1)
	lwz	r5, 20(r1)
	lwz	r6, 24(r1)
	lwz	r7, 28(r1)
	lwz	r8, 32(r1)
	lwz	r9, 36(r1)
	lwz	r10, 40(r1)
	lwz	r11, 44(r1)
	lwz	r12, 48(r1)
	lwz	r13, 52(r1)
	lwz	r14, 56(r1)
	lwz	r15, 60(r1)
	lwz	r16, 64(r1)
	lwz	r17, 68(r1)
	lwz	r18, 72(r1)
	lwz	r19, 76(r1)
	lwz	r20, 80(r1)
	lwz	r21, 84(r1)
	lwz	r22, 88(r1)
	lwz	r23, 92(r1)
	lwz	r24, 96(r1)
	lwz	r25, 100(r1)
	lwz	r26, 104(r1)
	lwz	r27, 108(r1)
	lwz	r28, 112(r1)
	lwz	r29, 116(r1)
	lwz	r30, 120(r1)
	lwz	r31, 124(r1)
	lwz	r0, 128(r1)
	mtlr	r0
	lwz	r0, 132(r1)
	mtcr	r0
	
	lwz	r1, 0(r1)

	rfi
	
