	.text

	.extern	main
	.extern int_handler
#====================================
#      Exception Vectors
#====================================
	# RESET
__reset_vector:				#$B"+%j%;%C%H%Y%/%?(B
	mov hilo(__startup), r1		#$B"-%i%Y%k(B__startup$B$K%8%c%s%W(B
	jmp r1
	nop				#$B",(B
	.org 0x10			#$B"+$3$N(B.text$B%;%/%7%g%s$N@hF,$+$i(B0x10$B%P%$%H%*%U%;%C%H$r3NJ](B
	# NMI				#$B"+(BNMI$BMQ%Y%/%?(B($B2?$b$7$J$$(B)
	.org 0x20			
	# INTWDT2			#$B"+(BWDT2$BMQ%Y%/%?!#0J9_$b(BV850$B$N;EMM$HF1$8JB$S$G%Y%/%?NN0h$,JB$V!#(B
	.org 0x40			
	# TRAP0n			#$B"+(BTRAP0n$BMQ%Y%/%?!#(B
	jr __global_exception_handler	#$B"+(B__global_exception_handler$B%i%Y%k$XJ,4t(B
	nop
	.org 0x50
	# TRAP1n			#$B"+(BTRAP0n$BMQ%Y%/%?!#(B
	jr __global_exception_handler	#$B"+(B__global_exception_handler$B%i%Y%k$XJ,4t(B
	nop
	.org 0x60
	# ILGOP/DBG0			#$B"+(BILGOP/DBG0$BMQ%Y%/%?!J2?$b$7$J$$!K!#(B
	nop
	nop
	.org 0x80
	# INTLVI			#$B"+(BINTLVI$BMQ%Y%/%?!J2?$b$7$J$$!K!#(B
	jr __global_exception_handler
	nop
	.org 0x90
	# INTP0				#$B"-30It3d$j9~$_(BINTP0-7$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0xA0
	# INTP1
	jr __global_exception_handler
	nop
	.org 0xB0
	# INTP2
	jr __global_exception_handler
	nop
	.org 0xC0
	# INTP3
	jr __global_exception_handler
	nop
	.org 0xD0
	# INTP4
	jr __global_exception_handler
	nop
	.org 0xE0
	# INTP5
	jr __global_exception_handler
	nop
	.org 0xF0
	# INTP6
	jr __global_exception_handler
	nop
	.org 0x100
	# INTP7
	jr __global_exception_handler
	nop				#$B",(B
	.org 0x110
	# INTTQ0OV			#$B"+(BINTTQ0OV$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x120
	# INTTQ0CC0			#$B"+(BINTTQ0CC0$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x130
	# INTTQ0CC1			#$B"+(BINTTQ0CC1$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x140
	# INTTQ0CC2			#$B"+(BINTTQ0CC2$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x150
	# INTTQ0CC3			#$B"+(BINTTQ0CC3$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x160
	# INTTP0OV			#$B"+(BINTTP0OV$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x170
	# INTTP0CC0			#$B"+(BINTTP0CC0$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x180
	# INTTP0CC1			#$B"+(BINTTP0CC1$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x190
	# INTTP1OV			#$B"+(BINTTP1OV$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x1A0
	# INTTP1CC0			#$B"+(BINTTP1CC0$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x1B0
	# INTTP1CC1			#$B"+(BINTTP1CC1$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x1C0
	# INTTP2OV			#$B"+(BINTTP2OV$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x1D0
	# INTTP2CC0			#$B"+(BINTTP2CC0$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x1E0
	# INTTP2CC1			#$B"+(BINTTP2CC1$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x1F0
	# INTTP3OV			#$B"+(BINTTP3OV$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x200
	# INTTP3CC0			#$B"+(BINTTP3CC0$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x210
	# INTTP3CC1			#$B"+(BINTTP3CC1$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x220
	# INTTP4OV			#$B"+(BINTTP4OV$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x230
	# INTTP4CC0			#$B"+(BINTTP4CC0$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x240
	# INTTP4CC1			#$B"+(BINTTP4CC1$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x250
	# INTTP5OV			#$B"+(BINTTP5OV$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x260
	# INTTP5CC0			#$B"+(BINTTP5CC0$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x270
	# INTTP5CC1			#$B"+(BINTTP5CC1$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x280
	# INTTM0EQ0			#$B"+(BINTTM0EQ0$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x290
	# INTCB0R/INTIIC1		#$B"+(BINTCB0R/INTIIC1$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x2A0
	# INTCB0T			#$B"+(BINTCB0T$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x2B0
	# INTCB1R			#$B"+(BINTCB1R$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x2C0
	# INTCB1T			#$B"+(BINTCB1T$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x2D0
	# INTCB2R			#$B"+(BINTCB2R$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x2E0
	# INTCB2T			#$B"+(BINTCB2T$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x2F0
	# INTCB3R			#$B"+(BINTCB3R$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x300
	# INTCB3T			#$B"+(BINTCB3T$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x310
	# INTUA0R/INTCB4R		#$B"+%7%j%"%k%A%c%M%k(B0$B$N<u?.3d$j9~$_$O%9%?%V$G;HMQ$9$k$?$a!"BeBX%Y%/%?$K$O%8%c%s%W$7$F$3$J$$!#(B
	nop
	nop
	.org 0x320
	# INTUA0T/INTCB4T		#$B"+(BINTUA0T/INTCB4T$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x330
	# INTUA1R/INTIIC2		#$B"+(BINTUA1R/INTIIC2$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x340
	# INTUA1T			#$B"+(BINTUA1T$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x350
	# INTUA2R/INTIIC0		#$B"+(BINTUA2R/INTIIC0$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x360
	# INTUA2T			#$B"+(BINTUA2T$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x370
	# INTAD				#$B"+(BINTAD$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x380
	# INTMA0			#$B"-(BINTMA0-3$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x390
	# INTMA1			
	jr __global_exception_handler
	nop
	.org 0x3A0
	# INTMA2			
	jr __global_exception_handler
	nop
	.org 0x3B0
	# INTMA3			
	jr __global_exception_handler
	nop				#$B",(B
	.org 0x3C0
	# INTKR			#$B"+(BINTKR$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x3D0
	# INTWTI		#$B"+(BINTWTI$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
	.org 0x3E0
	# INTWT			#$B"+(BINTWT$BMQ%Y%/%?!#(B__global_exception_handler$B%i%Y%k$XJ,4t$9$k!#(B
	jr __global_exception_handler
	nop
# GDB$B$G$O$3$3$+$i<B9T$,;O$^$j$^$9!#(B	
.org 0x400
	.global	__startup 
__startup:
.ifdef ROM_TARGET		#$B"-(B(A) ROM$B2=;~$N$_;HMQ$5$l$k!#$3$NItJ,$O%W%m%;%C%5$N5/F0D>8e$K<B9T$5$l$k$Y$-=i4|2=A`:n$,5-=R$5$l$k!#(B
	/* $B30It%P%9%&%'%$%H$J$7(B */
	mov	hilo(0xFFFFF06E), r1
	mov	hilo(0x01), r2
	st.b	r2, 0[r1]
	/* $B%&%)%C%A%I%C%/%?%$%^6X;_(B */
	mov  hilo(0xFFFFF6D0), r1
	st.b  r0, 0[r1]				/* WDTM2 stop */
	
	/* $B%*%s%A%C%W%G%P%C%0%b%8%e!<%k6X;_(B*/
	/* $B8e$[$IMW8!F$(B*/
	mov  hilo(0xFFFFF1FC), r1
	mov  hilo(0xFFFFF9FC), r3
	st.b  r0, 0[r1]
	st.b  r0, 0[r3]
	nop
	nop
	nop
	nop
	nop

	/* data$B%;%/%7%g%s$r(BROM->RAM$B%3%T!<(B */	#$B"-(BROM$B$KJ]B8$5$l$F$$$k=i4|2=:Q$_$N(Bdata$B%;%/%7%g%s$r(BRAM$BNN0h$K%3%T!<$9$k!#(B
	mov	hilo(_sdata_loadaddr), r1
	mov	hilo(_sdata), r2
	mov	hilo(_edata), r3
__copy_loop:	
	ld.b	0[r1], r4
	st.b	r4, 0[r2]
	addi	1, r1, r1
	addi	1, r2, r2
	cmp     r2, r3
	bh	__copy_loop
	nop					#$B",(B

.endif /* ROM_TARGET */	#$B",(B(A)
	
	# $B%9%?%C%/$r@_Dj$9$k(B
	mov	hilo(_stack_base), sp	#$B"+%f!<%6%W%m%0%i%`B&$G%9%?%C%/$r@_Dj(B
	

.ifndef ROM_TARGET		#$B"-(B(B)$B%f!<%6%W%m%0%i%`%G%P%C%0;~$N$_<B9T$9$k!%(BROM$B2=;~$O:o=|$5$l$k!%(B
	/* $B%9%?%C%/$K%l%8%9%?$rB`Hr$9$k(B*/
	addi	-4, sp, sp		#$B"-(Bep$B%l%8%9%?$NFbMF$r%9%?%C%/$K@Q$`(B
	st.w	ep, 0[sp]		#$B",(B
	
	addi	-128, sp, sp		#$B"-%9%?%C%/%]%$%s%?$r(Bep$B%l%8%9%?$KBeF~$7$F(Bep$B%l%8%9%?$r%$%s%G%C%/%9$H$7$FHFMQ%l%8%9%?$NFbMF$rB`Hr$9$k!#%9%?%V$+$i%@%&%s%m!<%I%W%m%0%i%`$r<B9T$9$k$H$-!"%9%?%V$G;H$C$F$$$?%l%8%9%?FbMF$rB`Hr$9$kI,MW$,$"$k!#(B
	mov	sp, ep
	sst.w	r0,  0[ep]
	sst.w	r1,  4[ep]
	sst.w	r2,  8[ep]
	sst.w	r3,  12[ep]
	sst.w	r4,  16[ep]
	sst.w	r5,  20[ep]
	sst.w	r6,  24[ep]
	sst.w	r7,  28[ep]
	sst.w	r8,  32[ep]
	sst.w	r9, 36[ep]
	sst.w	r10, 40[ep]
	sst.w	r11, 44[ep]
	sst.w	r12, 48[ep]
	sst.w	r13, 52[ep]
	sst.w	r14, 56[ep]
	sst.w	r15, 60[ep]
	sst.w	r16, 64[ep]
	sst.w	r17, 68[ep]
	sst.w	r18, 72[ep]
	sst.w	r19, 76[ep]
	sst.w	r20, 80[ep]
	sst.w	r21, 84[ep]
	sst.w	r22, 88[ep]
	sst.w	r23, 92[ep]
	sst.w	r24, 96[ep]
	sst.w	r25, 100[ep]
	sst.w	r26, 104[ep]
	sst.w	r27, 108[ep]
	sst.w	r28, 112[ep]
	sst.w	r29, 116[ep]
	sst.w	r31, 124[ep]		#$B",(B
	
	# $B%f!<%6Nc30%Y%/%?$N%Y!<%9%"%I%l%9$r@_Dj$7$^$9!#(B
	mov	hilo(0x03FFEFFC), r1	#$B"-FbB"(BRAM$B$N:G>e0L$N(B4$B%P%$%H$K!"BeBX%Y%/%?$N%"%I%l%9$r3JG<$9$k(B
	mov	hilo(_user_vector_base_addr), r2
	st.w	r2, 0[r1]		#$B",(B

	jarl	_main, lp		#$B"+(Bmain()$B4X?t$K%8%c%s%W(B
	nop

	sld.w	0[ep], r0		#$B"-B`Hr$7$?HFMQ%l%8%9%?$NFbMF$rI|5"(B
	sld.w	4[ep], r1
	sld.w	8[ep], r2
	sld.w	12[ep], r3
	sld.w	16[ep], r4
	sld.w	20[ep], r5
	sld.w	24[ep], r6
	sld.w	28[ep], r7
	sld.w	32[ep], r8
	sld.w	36[ep], r9
	sld.w	40[ep], r10
	sld.w	44[ep], r11
	sld.w	48[ep], r12
	sld.w	52[ep], r13
	sld.w	56[ep], r14
	sld.w	60[ep], r15
	sld.w	64[ep], r16
	sld.w	68[ep], r17
	sld.w	72[ep], r18
	sld.w	76[ep], r19
	sld.w	80[ep], r20
	sld.w	84[ep], r21
	sld.w	88[ep], r22
	sld.w	92[ep], r23
	sld.w	96[ep], r24
	sld.w	100[ep], r25
	sld.w	104[ep], r26
	sld.w	108[ep], r27
	sld.w	112[ep], r28
	sld.w	116[ep], r29
	sld.w	124[ep], r31
	addi	128, sp, sp		#$B",(B

	jmp	[lp]			#$B%9%?%V$GJ]B8$5$l$?(Blp$B$NFbMF!"$D$^$j!"%9%?%V$G%@%&%s%m!<%I%W%m%0%i%`$,8F$P$l$?%"%I%l%9$K%j%?!<%s$9$k!#(B
	nop
.endif /* !ROM_TARGET */		#$B",(B(B)

.ifdef ROM_TARGET			#$B"-(B(C)$B%f!<%6%W%m%0%i%`(BROM$B2=;~$N$_<B9T$9$k!%%G%P%C%0;~$O:o=|$5$l$k!%(B

	jarl	_main, lp		#$B"+(Bmain()$B4X?t$KLa$jHVCO$r(Blp$B$KJ]B8$7$FJ,4t$9$k!#(B
	nop
	halt				#$B"+(BROM$B2=;~$O(Bmain()$B4X?t$+$iLa$k$H$3$m$O$J$$$N$G(BCPU$B$rDd;_$5$;$k!#(B
	nop
.endif /* ROM_TARGET */
	
_loop_here:				#$B"+(BROM$B2=;~$K8m$C$F$3$3$^$GMh$?$H$-$KL58B%k!<%W$K4Y$i$;$k$?$a$N%;%$%U%F%#%M%C%H!#(B
	br	_loop_here

__global_exception_handler:		#$B"+Nc30%Y%/%?$+$i8F$P$l$k%0%m!<%P%k$NNc30%O%s%I%i!#$3$N4X?t$G$I$NNc30$,H/@8$7$F$$$k$+$rH=Dj$9$k!#(B
.ifndef ROM_TARGET			#$B"-(B(D)ROM$B2=;~$O:o=|$5$l$k!#(B
	sld.w	0[ep], r1		#$B"-%9%?%V$NNc30%O%s%I%i$G(Br1$B!"(Br2$B$,%9%?%C%/$KB`Hr$5$l$F$$$?$N$G%9%?%C%/$+$iI|5"$5$;$k!#(B
	sld.w	4[ep], r2
	addi	8, sp, sp

	ld.w	0[sp], ep
	addi	4, sp, sp
	nop				#$B",(B
.endif	/* !ROM_TARGET */		#$B",(B(C)
	
	
	/* $B%9%?%C%/$K%l%8%9%?$rB`Hr$9$k(B*/
	addi	-4, sp, sp		#$B"-%9%?%C%/$K%l%8%9%?$rB`Hr$9$k!#(B
	st.w	ep, 0[sp]
	
	addi	-128, sp, sp
	mov	sp, ep
	sst.w	r0,  0[ep]
	sst.w	r1,  4[ep]
	sst.w	r2,  8[ep]
	sst.w	r3,  12[ep]
	sst.w	r4,  16[ep]
	sst.w	r5,  20[ep]
	sst.w	r6,  24[ep]
	sst.w	r7,  28[ep]
	sst.w	r8,  32[ep]
	sst.w	r9, 36[ep]
	sst.w	r10, 40[ep]
	sst.w	r11, 44[ep]
	sst.w	r12, 48[ep]
	sst.w	r13, 52[ep]
	sst.w	r14, 56[ep]
	sst.w	r15, 60[ep]
	sst.w	r16, 64[ep]
	sst.w	r17, 68[ep]
	sst.w	r18, 72[ep]
	sst.w	r19, 76[ep]
	sst.w	r20, 80[ep]
	sst.w	r21, 84[ep]
	sst.w	r22, 88[ep]
	sst.w	r23, 92[ep]
	sst.w	r24, 96[ep]
	sst.w	r25, 100[ep]
	sst.w	r26, 104[ep]
	sst.w	r27, 108[ep]
	sst.w	r28, 112[ep]
	sst.w	r29, 116[ep]
	sst.w	r31, 124[ep]		#$B",(B

	stsr	ecr, r6			#$B"+(BECR$B$r(B_global_handler_func$B4X?t$NBh0l0z?t$K%;%C%H$7$F!"J,4t$9$k!#(B
	jarl	__global_handler_func, r31

	sld.w	0[ep], r0		#$B"-%l%8%9%?$r%9%?%C%/$+$iI|5"!#(B
	sld.w	4[ep], r1
	sld.w	8[ep], r2
	sld.w	12[ep], r3
	sld.w	16[ep], r4
	sld.w	20[ep], r5
	sld.w	24[ep], r6
	sld.w	28[ep], r7
	sld.w	32[ep], r8
	sld.w	36[ep], r9
	sld.w	40[ep], r10
	sld.w	44[ep], r11
	sld.w	48[ep], r12
	sld.w	52[ep], r13
	sld.w	56[ep], r14
	sld.w	60[ep], r15
	sld.w	64[ep], r16
	sld.w	68[ep], r17
	sld.w	72[ep], r18
	sld.w	76[ep], r19
	sld.w	80[ep], r20
	sld.w	84[ep], r21
	sld.w	88[ep], r22
	sld.w	92[ep], r23
	sld.w	96[ep], r24
	sld.w	100[ep], r25
	sld.w	104[ep], r26
	sld.w	108[ep], r27
	sld.w	112[ep], r28
	sld.w	116[ep], r29
	sld.w	124[ep], r31
	addi	128, sp, sp

	ld.w	0[sp], ep
	addi	4, sp, sp	#$B",(B
	reti
	nop
	
