	.text

#==============================
#      V850E Exception Vectors
#==============================
	# RESET
	jr __startup
	nop
	.org 0x10
	# NMI
	.org 0x20
	# INTWDT2
	.org 0x40
	# TRAP0n
	jr __global_exception_handler
	nop
	.org 0x50
	# TRAP1n
	jr __global_exception_handler
	nop
	.org 0x60
	# ILGOP/DBG0
	jr __ilgop_dbtrap_exception
	nop
	.org 0x80
	# INTLVI
	jr __global_exception_handler
	nop
	.org 0x90
	# INTP0
	jr __global_exception_handler
	nop
	.org 0xA0
	# INTP1
	jr __global_exception_handler
	nop
	.org 0xB0
	# INTP2
	jr __global_exception_handler
	nop
	.org 0xC0
	# INTP3
	jr __global_exception_handler
	nop
	.org 0xD0
	# INTP4
	jr __global_exception_handler
	nop
	.org 0xE0
	# INTP5
	jr __global_exception_handler
	nop
	.org 0xF0
	# INTP6
	jr __global_exception_handler
	nop
	.org 0x100
	# INTP7
	jr __global_exception_handler
	nop
	.org 0x110
	# INTTQ0OV
	jr __global_exception_handler
	nop
	.org 0x120
	# INTTQ0CC0
	jr __global_exception_handler
	nop
	.org 0x130
	# INTTQ0CC1
	jr __global_exception_handler
	nop
	.org 0x140
	# INTTQ0CC2
	jr __global_exception_handler
	nop
	.org 0x150
	# INTTQ0CC3
	jr __global_exception_handler
	nop
	.org 0x160
	# INTTP0OV
	jr __global_exception_handler
	nop
	.org 0x170
	# INTTP0CC0
	jr __global_exception_handler
	nop
	.org 0x180
	# INTTP0CC1
	jr __global_exception_handler
	nop
	.org 0x190
	# INTTP1OV
	jr __global_exception_handler
	nop
	.org 0x1A0
	# INTTP1CC0
	jr __global_exception_handler
	nop
	.org 0x1B0
	# INTTP1CC1
	jr __global_exception_handler
	nop
	.org 0x1C0
	# INTTP2OV
	jr __global_exception_handler
	nop
	.org 0x1D0
	# INTTP2CC0
	jr __global_exception_handler
	nop
	.org 0x1E0
	# INTTP2CC1
	jr __global_exception_handler
	nop
	.org 0x1F0
	# INTTP3OV
	jr __global_exception_handler
	nop
	.org 0x200
	# INTTP3CC0
	jr __global_exception_handler
	nop
	.org 0x210
	# INTTP3CC1
	jr __global_exception_handler
	nop
	.org 0x220
	# INTTP4OV
	jr __global_exception_handler
	nop
	.org 0x230
	# INTTP4CC0
	jr __global_exception_handler
	nop
	.org 0x240
	# INTTP4CC1
	jr __global_exception_handler
	nop
	.org 0x250
	# INTTP5OV
	jr __global_exception_handler
	nop
	.org 0x260
	# INTTP5CC0
	jr __global_exception_handler
	nop
	.org 0x270
	# INTTP5CC1
	jr __global_exception_handler
	nop
	.org 0x280
	# INTTM0EQ0
	jr __global_exception_handler
	nop
	.org 0x290
	# INTCB0R/INTIIC1
	jr __global_exception_handler
	nop
	.org 0x2A0
	# INTCB0T
	jr __global_exception_handler
	nop
	.org 0x2B0
	# INTCB1R
	jr __global_exception_handler
	nop
	.org 0x2C0
	# INTCB1T
	jr __global_exception_handler
	nop
	.org 0x2D0
	# INTCB2R
	jr __global_exception_handler
	nop
	.org 0x2E0
	# INTCB2T
	jr __global_exception_handler
	nop
	.org 0x2F0
	# INTCB3R
	jr __global_exception_handler
	nop
	.org 0x300
	# INTCB3T
	jr __global_exception_handler
	nop
	.org 0x310
	# INTUA0R/INTCB4R
	jr __uart0rxint
	nop
	.org 0x320
	# INTUA0T/INTCB4T
	jr __global_exception_handler
	nop
	.org 0x330
	# INTUA1R/INTIIC2
	jr __global_exception_handler
	nop
	.org 0x340
	# INTUA1T
	jr __global_exception_handler
	nop
	.org 0x350
	# INTUA2R/INTIIC0
	jr __global_exception_handler
	nop
	.org 0x360
	# INTUA2T
	jr __global_exception_handler
	nop
	.org 0x370
	# INTAD
	jr __global_exception_handler
	nop
	.org 0x380
	# INTMA0
	jr __global_exception_handler
	nop
	.org 0x390
	# INTMA1
	jr __global_exception_handler
	nop
	.org 0x3A0
	# INTMA2
	jr __global_exception_handler
	nop
	.org 0x3B0
	# INTMA3
	jr __global_exception_handler
	nop
	.org 0x3C0
	# INTKR
	jr __global_exception_handler
	nop
	.org 0x3D0
	# INTWTI
	jr __global_exception_handler
	nop
	.org 0x3E0
	# INTWT
	jr __global_exception_handler
	nop	
.org 0x400
	.global	__startup
__startup:
	di
	/* $B30It%P%9%&%'%$%H$J$7(B */
	mov	hilo(0xFFFFF06E), r1
	mov	hilo(0x01), r2
	st.b	r2, 0[r1]
	/* $B%&%)%C%A%I%C%/%?%$%^6X;_(B */
	mov  hilo(0xFFFFF6D0), r1
	st.b  r0, 0[r1]				/* WDTM2 stop */
	
	/* $B%*%s%A%C%W%G%P%C%0%b%8%e!<%k6X;_(B*/
	mov  hilo(0xFFFFF1FC), r1
	mov  hilo(0xFFFFF9FC), r3
	st.b  r0, 0[r1]
	st.b  r0, 0[r3]
	nop
	nop
	nop
	nop
	nop

	mov	hilo(_sp_base), sp
	jr	_main
	nop
	halt
	nop
__global_exception_handler:
	/* $B%9%?%C%/$K%l%8%9%?$rB`Hr$9$k(B*/
	addi	-4, sp, sp
	st.w	ep, 0[sp]
	
	addi	-8, sp, sp
	mov	sp, ep
	sst.w	r1,  0[ep]
	sst.w	r2,  4[ep]

	# _user_exception_vector_addr+$BNc30%3!<%I(B=$BHt$S@h%"%I%l%9(B
	stsr	ecr, r1
	andi	0xFFFF, r1, r1
	mov	hilo(_user_exception_vector_addr), r2
	ld.w	0[r2], r2
	add	r1, r2
	jmp	[r2]

#	$B%@%&%s%m!<%I$5$l$kB&$N%O%s%I%i$NF,$K0J2<$r=q$/I,MW$,$"$j$^$9!#(B
#	sld.w	0[ep], r1
#	sld.w	4[ep], r2
#	addi	8, sp, sp
#
#	ld.w	0[sp], ep
#	addi	4, sp, sp
#	nop
	
__uart0rxint:
	/* GDB$B$KJV$9%l%8%9%?NN0h$K%l%8%9%?$rB`Hr$9$k$?$a(B
	ep$B$rB`Hr$9$k(B*/
	add	-4, sp
	st.w	ep, 0[sp]
	
	mov	hilo(_registers), ep
		
	/* $BB`Hr$9$k(B*/
	sst.w	r0,  0[ep]
	sst.w	r1,  4[ep]
	sst.w	r2,  8[ep]
	sst.w	r3,  12[ep]
	sst.w	r4,  16[ep]
	sst.w	r5,  20[ep]
	sst.w	r6,  24[ep]
	sst.w	r7,  28[ep]
	sst.w	r8,  32[ep]
	sst.w	r9, 36[ep]
	sst.w	r10, 40[ep]
	sst.w	r11, 44[ep]
	sst.w	r12, 48[ep]
	sst.w	r13, 52[ep]
	sst.w	r14, 56[ep]
	sst.w	r15, 60[ep]
	sst.w	r16, 64[ep]
	sst.w	r17, 68[ep]
	sst.w	r18, 72[ep]
	sst.w	r19, 76[ep]
	sst.w	r20, 80[ep]
	sst.w	r21, 84[ep]
	sst.w	r22, 88[ep]
	sst.w	r23, 92[ep]
	sst.w	r24, 96[ep]
	sst.w	r25, 100[ep]
	sst.w	r26, 104[ep]
	sst.w	r27, 108[ep]
	sst.w	r28, 112[ep]
	sst.w	r29, 116[ep]
	ld.w	0[sp], r2
	sst.w	r2, 120[ep]
	sst.w	r31, 124[ep]
	stsr	eipc, r4
	sst.w	r4 , 128[ep]
	stsr	eipsw, r4
	sst.w	r4 , 132[ep]
	stsr	fepc, r4
	sst.w	r4 , 136[ep]
	stsr	fepsw, r4
	sst.w	r4 , 140[ep]
	stsr	ecr, r4
	sst.w	r4 , 144[ep]
	stsr	psw, r4
	sst.w	r4 , 148[ep]
	stsr	ctpc, r4
	sst.w	r4 , 152[ep]
	stsr	ctpsw, r4
	sst.w	r4 , 156[ep]
	stsr	dbpc, r4
	sst.w	r4 , 160[ep]
	stsr	dbpsw, r4
	sst.w	r4 , 164[ep]
	stsr	ctbp, r4
	sst.w	r4 , 168[ep]
	addi	256, ep, ep
	stsr	eipc, r4
	sst.w	r4 , 0[ep]
	mov	r3, r4
	sst.w	r4 , 4[ep]

	jarl    __int_func, r31

	mov	hilo(_registers), ep

	sld.w	0[ep], r0
	sld.w	4[ep], r1
	sld.w	8[ep], r2
	sld.w	12[ep], r3
	sld.w	20[ep], r5
	sld.w	24[ep], r6
	sld.w	28[ep], r7
	sld.w	32[ep], r8
	sld.w	36[ep], r9
	sld.w	40[ep], r10
	sld.w	44[ep], r11
	sld.w	48[ep], r12
	sld.w	52[ep], r13
	sld.w	56[ep], r14
	sld.w	60[ep], r15
	sld.w	64[ep], r16
	sld.w	68[ep], r17
	sld.w	72[ep], r18
	sld.w	76[ep], r19
	sld.w	80[ep], r20
	sld.w	84[ep], r21
	sld.w	88[ep], r22
	sld.w	92[ep], r23
	sld.w	96[ep], r24
	sld.w	100[ep], r25
	sld.w	104[ep], r26
	sld.w	108[ep], r27
	sld.w	112[ep], r28
	sld.w	116[ep], r29
	sld.w	124[ep], r31

	sld.w	128[ep], r4 
	ldsr	r4, eipc
	sld.w	132[ep], r4 
	ldsr	r4, eipsw
	sld.w	136[ep], r4 
	ldsr	r4, fepc
	sld.w	140[ep], r4 
	ldsr	r4, fepsw
	sld.w	144[ep], r4 
	ldsr	r4, ecr
	sld.w	148[ep], r4 
	ldsr	r4, psw
	sld.w	152[ep], r4 
	ldsr	r4, ctpc
	sld.w	156[ep], r4 
	ldsr	r4, ctpsw
	sld.w	160[ep], r4 
	ldsr	r4, dbpc
	sld.w	164[ep], r4 
	ldsr	r4, dbpsw
	sld.w	168[ep], r4 
	ldsr	r4, ctbp

	sld.w	16[ep], r4
	ld.w    0[sp], ep
	add     4, sp

	reti
	nop
__ilgop_dbtrap_exception:
	/* GDB$B$KJV$9%l%8%9%?NN0h$K%l%8%9%?$rB`Hr$9$k$?$a(B
	ep$B$rB`Hr$9$k(B*/
	di
	add	-4, sp
	st.w	ep, 0[sp]
	
	mov	hilo(_registers), ep
		
	/* $BB`Hr$9$k(B*/
	sst.w	r0,  0[ep]
	sst.w	r1,  4[ep]
	sst.w	r2,  8[ep]
	sst.w	r3,  12[ep]
	sst.w	r4,  16[ep]
	sst.w	r5,  20[ep]
	sst.w	r6,  24[ep]
	sst.w	r7,  28[ep]
	sst.w	r8,  32[ep]
	sst.w	r9, 36[ep]
	sst.w	r10, 40[ep]
	sst.w	r11, 44[ep]
	sst.w	r12, 48[ep]
	sst.w	r13, 52[ep]
	sst.w	r14, 56[ep]
	sst.w	r15, 60[ep]
	sst.w	r16, 64[ep]
	sst.w	r17, 68[ep]
	sst.w	r18, 72[ep]
	sst.w	r19, 76[ep]
	sst.w	r20, 80[ep]
	sst.w	r21, 84[ep]
	sst.w	r22, 88[ep]
	sst.w	r23, 92[ep]
	sst.w	r24, 96[ep]
	sst.w	r25, 100[ep]
	sst.w	r26, 104[ep]
	sst.w	r27, 108[ep]
	sst.w	r28, 112[ep]
	sst.w	r29, 116[ep]
	ld.w	0[sp], r2
	sst.w	r2, 120[ep]
	sst.w	r31, 124[ep]
	stsr	eipc, r4
	sst.w	r4 , 128[ep]
	stsr	eipsw, r4
	sst.w	r4 , 132[ep]
	stsr	fepc, r4
	sst.w	r4 , 136[ep]
	stsr	fepsw, r4
	sst.w	r4 , 140[ep]
	stsr	ecr, r4
	sst.w	r4 , 144[ep]
	stsr	psw, r4
	sst.w	r4 , 148[ep]
	stsr	ctpc, r4
	sst.w	r4 , 152[ep]
	stsr	ctpsw, r4
	sst.w	r4 , 156[ep]
	stsr	dbpc, r4
	sst.w	r4 , 160[ep]
	stsr	dbpsw, r4
	sst.w	r4 , 164[ep]
	stsr	ctbp, r4
	sst.w	r4 , 168[ep]
	addi	256, ep, ep
	stsr	dbpc, r4
	addi	-2, r4, r4
	sst.w	r4 , 0[ep]
	mov	r3, r4
	sst.w	r4 , 4[ep]

	#dbtrap$BL?Na$N>l9g$O(BDIR.DM$B$,%;%C%H$5$l$k(B
	stsr	dir, r4
	andi	1, r4, r4
	cmp	1, r4
	bne	__ill_br
__dbtrap_br:	
	jarl    __trap_func, r31
	
	mov	hilo(_registers), ep

	sld.w	0[ep], r0
	sld.w	4[ep], r1
	sld.w	8[ep], r2
	sld.w	12[ep], r3
	sld.w	20[ep], r5
	sld.w	24[ep], r6
	sld.w	28[ep], r7
	sld.w	32[ep], r8
	sld.w	36[ep], r9
	sld.w	40[ep], r10
	sld.w	44[ep], r11
	sld.w	48[ep], r12
	sld.w	52[ep], r13
	sld.w	56[ep], r14
	sld.w	60[ep], r15
	sld.w	64[ep], r16
	sld.w	68[ep], r17
	sld.w	72[ep], r18
	sld.w	76[ep], r19
	sld.w	80[ep], r20
	sld.w	84[ep], r21
	sld.w	88[ep], r22
	sld.w	92[ep], r23
	sld.w	96[ep], r24
	sld.w	100[ep], r25
	sld.w	104[ep], r26
	sld.w	108[ep], r27
	sld.w	112[ep], r28
	sld.w	116[ep], r29
	sld.w	124[ep], r31

	sld.w	128[ep], r4 
	ldsr	r4, eipc
	sld.w	132[ep], r4 
	ldsr	r4, eipsw
	sld.w	136[ep], r4 
	ldsr	r4, fepc
	sld.w	140[ep], r4 
	ldsr	r4, fepsw
	sld.w	144[ep], r4 
	ldsr	r4, ecr
	sld.w	148[ep], r4 
	ldsr	r4, psw
	sld.w	152[ep], r4 
	ldsr	r4, ctpc
	sld.w	156[ep], r4 
	ldsr	r4, ctpsw
	sld.w	160[ep], r4 
	ldsr	r4, dbpc
	sld.w	164[ep], r4 
	ldsr	r4, dbpsw
	sld.w	168[ep], r4 
	ldsr	r4, ctbp

	sld.w	16[ep], r4
	ld.w    0[sp], ep
	add     4, sp
	ei

	dbret
__ill_br:		
	jarl    __illegalinst_func, r31

	mov	hilo(_registers), ep

	sld.w	0[ep], r0
	sld.w	4[ep], r1
	sld.w	8[ep], r2
	sld.w	12[ep], r3
	sld.w	20[ep], r5
	sld.w	24[ep], r6
	sld.w	28[ep], r7
	sld.w	32[ep], r8
	sld.w	36[ep], r9
	sld.w	40[ep], r10
	sld.w	44[ep], r11
	sld.w	48[ep], r12
	sld.w	52[ep], r13
	sld.w	56[ep], r14
	sld.w	60[ep], r15
	sld.w	64[ep], r16
	sld.w	68[ep], r17
	sld.w	72[ep], r18
	sld.w	76[ep], r19
	sld.w	80[ep], r20
	sld.w	84[ep], r21
	sld.w	88[ep], r22
	sld.w	92[ep], r23
	sld.w	96[ep], r24
	sld.w	100[ep], r25
	sld.w	104[ep], r26
	sld.w	108[ep], r27
	sld.w	112[ep], r28
	sld.w	116[ep], r29
	sld.w	124[ep], r31

	sld.w	128[ep], r4 
	ldsr	r4, eipc
	sld.w	132[ep], r4 
	ldsr	r4, eipsw
	sld.w	136[ep], r4 
	ldsr	r4, fepc
	sld.w	140[ep], r4 
	ldsr	r4, fepsw
	sld.w	144[ep], r4 
	ldsr	r4, ecr
	sld.w	148[ep], r4 
	ldsr	r4, psw
	sld.w	152[ep], r4 
	ldsr	r4, ctpc
	sld.w	156[ep], r4 
	ldsr	r4, ctpsw
	sld.w	160[ep], r4 
	ldsr	r4, dbpc
	sld.w	164[ep], r4 
	ldsr	r4, dbpsw
	sld.w	168[ep], r4 
	ldsr	r4, ctbp

	sld.w	16[ep], r4
	ld.w    0[sp], ep
	add     4, sp
	ei

	reti

	.global	_save_registers
	.align 0x4
_save_registers:
	/* GDB$B$KJV$9%l%8%9%?NN0h$K%l%8%9%?$rB`Hr$9$k$?$a(B
	ep$B$rB`Hr$9$k(B*/
	add	-4, sp
	st.w	ep, 0[sp]
	
	mov	hilo(_registers), ep
		
	/* $BB`Hr$9$k(B*/
	sst.w	r0,  0[ep]
	sst.w	r1,  4[ep]
	sst.w	r2,  8[ep]
	sst.w	r3,  12[ep]
	sst.w	r4,  16[ep]
	sst.w	r5,  20[ep]
	sst.w	r6,  24[ep]
	sst.w	r7,  28[ep]
	sst.w	r8,  32[ep]
	sst.w	r9, 36[ep]
	sst.w	r10, 40[ep]
	sst.w	r11, 44[ep]
	sst.w	r12, 48[ep]
	sst.w	r13, 52[ep]
	sst.w	r14, 56[ep]
	sst.w	r15, 60[ep]
	sst.w	r16, 64[ep]
	sst.w	r17, 68[ep]
	sst.w	r18, 72[ep]
	sst.w	r19, 76[ep]
	sst.w	r20, 80[ep]
	sst.w	r21, 84[ep]
	sst.w	r22, 88[ep]
	sst.w	r23, 92[ep]
	sst.w	r24, 96[ep]
	sst.w	r25, 100[ep]
	sst.w	r26, 104[ep]
	sst.w	r27, 108[ep]
	sst.w	r28, 112[ep]
	sst.w	r29, 116[ep]
	ld.w	0[sp], r2
	sst.w	r2, 120[ep]
	sst.w	r31, 124[ep]
	stsr	eipc, r4
	sst.w	r4 , 128[ep]
	stsr	eipsw, r4
	sst.w	r4 , 132[ep]
	stsr	fepc, r4
	sst.w	r4 , 136[ep]
	stsr	fepsw, r4
	sst.w	r4 , 140[ep]
	stsr	ecr, r4
	sst.w	r4 , 144[ep]
	stsr	psw, r4
	sst.w	r4 , 148[ep]
	stsr	ctpc, r4
	sst.w	r4 , 152[ep]
	stsr	ctpsw, r4
	sst.w	r4 , 156[ep]
	stsr	dbpc, r4
	sst.w	r4 , 160[ep]
	stsr	dbpsw, r4
	sst.w	r4 , 164[ep]
	stsr	ctbp, r4
	sst.w	r4 , 168[ep]
	addi	256, ep, ep
	stsr	dbpc, r4
	addi	-2, r4, r4
	sst.w	r4 , 0[ep]
	mov	r3, r4
	sst.w	r4 , 4[ep]

	ld.w    0[sp], ep
	add     4, sp
	jmp	lp
	