	.text

	.extern		main
	.extern		_sp_base
#======================================
#      Initialize vectors
#
##     0x00 	 Reset
##     0x04 	 Undefined Instruction
##     0x08 	 Software Interrupt
##     0x0c 	 Abort(prefetch)
##     0x10 	 Abort(data)
##     0x14 	 Reserved
##     0x18 	 IRQ
##     0x1c 	 FIQ
#======================================

	B	_startup
	B	_undefined_instruction_exception
	B	_software_exception
	B	_prefetch_abort_handle
	B	_data_abort_handle
	nop
	B	_IRQ_handle
	B	_FIQ_handle
	.org 0x20	
	.global _startup
_startup:
#IRQʒm󂯎悤ɐݒ肷
	MRS	R0, cpsr
	eor	R0, R0, #0x80
	MSR	cpsr, R0
#vZbT[hIRQ[h	
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x12
	MSR	CPSR, R1
#OnhpX^bNݒ
	LDR	sp, = _exception_sp_base
#vZbT[h𖢒`ߗO[h	
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x1B
	MSR	CPSR, R1
#OnhpX^bNݒ
	LDR	sp, = _exception_sp_base
#vZbT[habt[h	
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x17
	MSR	CPSR, R1
#OnhpX^bNݒ
	LDR	sp, = _exception_sp_base
#vZbT[hX[p[oCU[h֖߂
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x13
	MSR	CPSR, R1
		
	LDR	R13,=_sp_base
	BL	main

	.extern stub_stack
	.extern registers
	.extern _illegalinst_func
# GDBŐݒ肳ꂽu[N|CgOŁA
# _E[hꂽvOł͎gp֎~
	.align 0x4
_undefined_instruction_exception: 
	#OpX^bNɃWX^ޔ	
	STMDB	sp!,{r0-r12,r14}
	MRS	r0, spsr
	STMDB	sp!, {r0}
	
#vZbT[hX[p[oCU[h֖߂
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x13
	MSR	CPSR, R1

	#WX^L^܂B
	ldr	r0 ,=registers
	STMIA	r0!,{r0-r13}
#	add	r0, r0, #60

#vZbT[h𖢒`ߗO[h	
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x1B
	MSR	CPSR, R1

	STMIA	r0!,{r14}
	STMIA	r0!,{r14}
	STMIA	r0!,{r1}
	STMIA	r0!,{r1}
	
	bl	_illegalinst_func

	LDMIA	sp!, {r0}
	MSR	spsr_cf, r0
	
	LDMIA	sp!,{r0-r12,r14}
	#`߂̔ԒnɕA
	movs	PC, R14

	.align 0x4
_software_exception:
	#OpX^bNr0ޔ
	STMDB	sp!, {r0}

	LDR	R0,=_user_exception_vector_addr
	LDR	R0, [R0]
	add	R0, R0, #8
	mov	pc, r0

	

#ȉ̗O̓_E[hX^[gAbv[`̂̂g
#ɂ̂܂ܕ򂷂
	.align 0x4
_prefetch_abort_handle:	
	#OpX^bNr0ޔ
	STMDB	sp!, {r0}

	LDR	R0,=_user_exception_vector_addr
	LDR	R0, [R0]
	add	R0, R0, #0xC
	mov	PC, R0	
_data_abort_handle:
	#OpX^bNr0ޔ
	STMFD	sp!, {r0}
	LDR	R0,=_user_exception_vector_addr
	LDR	R0, [R0, #0]
	add	R0, R0, #0x10
	bx	R0
	
_IRQ_handle:	
	#OpX^bNɃWX^ޔ
	STMDB	sp!,{r0-r12, r14}
	MRS	r0, spsr
	STMDB	sp!, {r0}

#vZbT[hX[p[oCU[h֖߂
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x13
	MSR	CPSR, R1

	#WX^L^܂B
	ldr	r0 ,=registers
	STMIA	r0!,{r0-r13}

#vZbT[hIRQ[h	
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x12
	MSR	CPSR, R1

	#Thumb̂ƂAARM̗̎OLRPC+4łB
	SUB	r2, r14, #4
	str	r2, [r0, #0]
	str	r2, [r0, #4]
	str	r1, [r0, #8]

	#VA̎MOȂ̂ŁAGDB
	# COMSTA0̍ŉʃrbg𒲂ׂ1ȂGDB
	LDR	R0, =0xFFFF0714
	LDR	R0, [R0]
	AND	R0, R0, #0x1
	CMP	R0, #1
	bleq	_gdb_irq
	b	_user_IRQ_branch
_gdb_irq:	
	bl	_int_func

	#OpX^bN烌WX^A	
	LDMIA	sp!, {r0}
	MSR	spsr_cf, r0
	LDMIA	sp!,{r0-r12, r14}

	SUBS	PC, R14, #4
	
_user_IRQ_branch:	
	#OpX^bN烌WX^A	
	LDMIA	sp!, {r0}
	MSR	spsr_cf, r0
	LDMIA	sp!,{r0-r12, r14}

	#OpX^bNr0ޔ
	STMDB	sp!, {r0}

	LDR	R0,=_user_exception_vector_addr
	LDR	R0, [R0]
	add	R0, R0, #0x18
	mov	PC, R0

	.align 0x4
_FIQ_handle:	
	#OpX^bNɃWX^ޔ
	STMDB	sp!,{r0-r12}
	MRS	r0, spsr
	STMDB	sp!, {r0}

#vZbT[hX[p[oCU[h֖߂
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x13
	MSR	CPSR, R1

	#[hWX^L^܂B
	ldr	r0 ,=registers
	STMIA	r0!,{r0-r14}

#vZbT[hIRQ[h	
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x12
	MSR	CPSR, R1

	#Thumb̂ƂAARM̗̎OLRPC+4łB
	SUB	r2, r14, #4
	str	r2, [r0, #0]

	#VA̎MOȂ̂ŁAGDB
	# COMSTA0̍ŉʃrbg𒲂ׂ1ȂGDB
	LDR	R0, =0xFFFF0714
	LDR	R0, [R0]
	AND	R0, R0, #0x1
	CMP	R0, #1	
	bleq	_int_func
	b	_user_FIQ_branch	
	#OpX^bN烌WX^A	
	LDMIA	sp!, {r0}
	MSR	spsr_cf, r0
	LDMIA	sp!,{r0-r12}

	SUBS	PC, R14, #4
	
	.align 0x4
_user_FIQ_branch:	
	#OpX^bN烌WX^A	
	LDMIA	sp!, {r0}
	MSR	spsr_cf, r0
	LDMIA	sp!,{r0-r12}

	#OpX^bNr0ޔ
	STMDB	sp!, {r0}

	LDR	R0,=_user_exception_vector_addr
	LDR	R0, [R0, #0]
	add	R0, R0, #0x1C
	mov	PC, R0	
	