	.text

	.extern		main
	.extern		_sp_base
	.long     _sp_base+1	            
        .long     __startup+1
	.long     NMI_Handler+1
	.long     HardFault_Handler+1
	.long     MemManage_Handler+1
	.long     BusFault_Handler+1
	.long     UsageFault_Handler+1
	.org 0x2C
	.long     SVC_Handler+1
	.long     DebugMon_Handler+1
	.org 0x38
	.long     PendSV_Handler+1
	.long     SysTick_Handler+1

	.long     WWDG_IRQHandler+1
	.long     PVD_IRQHandler+1
	.long     TAMPER_IRQHandler+1
	.long     RTC_IRQHandler+1
	.long     FLASH_IRQHandler+1
	.long     RCC_IRQHandler+1
	.long     EXTI0_IRQHandler+1
	.long     EXTI1_IRQHandler+1
	.long     EXTI2_IRQHandler+1
	.long     EXTI3_IRQHandler+1
	.long     EXTI4_IRQHandler+1
	.long     DMAChannel1_IRQHandler+1
	.long     DMAChannel2_IRQHandler+1
	.long     DMAChannel3_IRQHandler+1
	.long     DMAChannel4_IRQHandler+1
	.long     DMAChannel5_IRQHandler+1
	.long     DMAChannel6_IRQHandler+1
	.long     DMAChannel7_IRQHandler+1
	.long     ADC_IRQHandler+1
	.long     USB_HP_CAN_TX_IRQHandler+1
	.long     USB_LP_CAN_RX0_IRQHandler+1
	.long     CAN_RX1_IRQHandler+1
	.long     CAN_SCE_IRQHandler+1
	.long     EXTI9_5_IRQHandler+1
	.long     TIM1_BRK_IRQHandler+1
	.long     TIM1_UP_IRQHandler+1
	.long     TIM1_TRG_COM_IRQHandler+1
	.long     TIM1_CC_IRQHandler+1
	.long     TIM2_IRQHandler+1
	.long     TIM3_IRQHandler+1
	.long     TIM4_IRQHandler+1
	.long     I2C1_EV_IRQHandler+1
	.long     I2C1_ER_IRQHandler+1
	.long     I2C2_EV_IRQHandler+1
	.long     I2C2_ER_IRQHandler+1
	.long     SPI1_IRQHandler+1
	.long     SPI2_IRQHandler+1
	.long     USART1_IRQHandler+1
	.long     USART2_IRQHandler+1
	.long     USART3_IRQHandler+1
	.long     EXTI15_10_IRQHandler+1
	.long     RTCAlarm_IRQHandler+1
	.long     USBWakeUp_IRQHandler+1
.org 0xEC		
__startup:
	LDR     R0, =main
	LDR	R1, =0x1 /*ToAgZbg*/
	ORR     R0, R1
        BX      R0 /*main֐֕򂷂B*/

NMI_Handler:
	LDR	R0, =0x0008
	B	_BranchGlobalHandler	
HardFault_Handler:
	# registerszɃWX^obNAbv
	LDR	R1, =registers
	# X^bNɑޔꂽ
	# r0,r1,r2,r3,r12,LR,PC,xPSR
	# registersɕۑ
	LDR	R0, [SP, #0x0]
	STR	R0, [R1, #0x0]
	LDR	R0, [SP, #0x4]
	STR	R0, [R1, #0x4]
	LDR	R0, [SP, #0x8]
	STR	R0, [R1, #0x8]
	LDR	R0, [SP, #0xC]
	STR	R0, [R1, #0xC]
	LDR	R0, [SP, #0x10]
	STR	R0, [R1, #0x30]
	LDR	R0, [SP, #0x14]
	STR	R0, [R1, #0x38]
	LDR	R0, [SP, #0x18]
	STR	R0, [R1, #0x3C]
	LDR	R0, [SP, #0x1C]
	STR	R0, [R1, #0x44]
	#c̃WX^ۑ
	STR	R4, [R1, #0x10]
	STR	R5, [R1, #0x14]
	STR	R6, [R1, #0x18]
	STR	R7, [R1, #0x1C]
	MOV	R0, R8
	STR	R0, [R1, #0x20]
	MOV	R0, R9
	STR	R0, [R1, #0x24]
	MOV	R0, R10
	STR	R0, [R1, #0x28]
	MOV	R0, R11
	STR	R0, [R1, #0x2C]
	MOV	R0, R12
	STR	R0, [R1, #0x30]
	SUB	R0, R0, #0x20
	MOV	R0, SP
	STR	R0, [R1, #0x34]

	LDR	R0, =0x000C
	B	_illegalinst_func
MemManage_Handler:	
	LDR	R0, =0x0010
	B	_BranchGlobalHandler	
BusFault_Handler:	
	LDR	R0, =0x0014
	B	_BranchGlobalHandler	
UsageFault_Handler:	
	LDR	R0, =0x0018
	B	_BranchGlobalHandler	
SVC_Handler:	
	LDR	R0, =0x002C
	B	_BranchGlobalHandler	
DebugMon_Handler:	
	LDR	R0, =0x0030
	B	_BranchGlobalHandler	
PendSV_Handler:	
	LDR	R0, =0x0038
	B	_BranchGlobalHandler	
SysTick_Handler:	
	LDR	R0, =0x003C
	B	_BranchGlobalHandler	



	
WWDG_IRQHandler:
	LDR	R0, =0x40
	B	_BranchGlobalHandler
PVD_IRQHandler:	
	LDR	R0, =0x44
	B	_BranchGlobalHandler
TAMPER_IRQHandler:	
	LDR	R0, =0x48
	B	_BranchGlobalHandler
RTC_IRQHandler:	
	LDR	R0, =0x4C
	B	_BranchGlobalHandler
FLASH_IRQHandler:	
	LDR	R0, =0x50
	B	_BranchGlobalHandler
RCC_IRQHandler:	
	LDR	R0, =0x54
	B	_BranchGlobalHandler
EXTI0_IRQHandler:	
	LDR	R0, =0x58
	B	_BranchGlobalHandler
EXTI1_IRQHandler:
	LDR	R0, =0x5C
	B	_BranchGlobalHandler
EXTI2_IRQHandler:	
	LDR	R0, =0x60
	B	_BranchGlobalHandler
EXTI3_IRQHandler:	
	LDR	R0, =0x64
	B	_BranchGlobalHandler
EXTI4_IRQHandler:	
	LDR	R0, =0x68
	B	_BranchGlobalHandler
DMAChannel1_IRQHandler:	
	LDR	R0, =0x6C
	B	_BranchGlobalHandler
DMAChannel2_IRQHandler:	
	LDR	R0, =0x70
	B	_BranchGlobalHandler
DMAChannel3_IRQHandler:	
	LDR	R0, =0x74
	B	_BranchGlobalHandler
DMAChannel4_IRQHandler:	
	LDR	R0, =0x78
	B	_BranchGlobalHandler
DMAChannel5_IRQHandler:	
	LDR	R0, =0x7C
	B	_BranchGlobalHandler
DMAChannel6_IRQHandler:	
	LDR	R0, =0x80
	B	_BranchGlobalHandler
DMAChannel7_IRQHandler:	
	LDR	R0, =0x84
	B	_BranchGlobalHandler
ADC_IRQHandler:	
	LDR	R0, =0x88
	B	_BranchGlobalHandler
USB_HP_CAN_TX_IRQHandler:	
	LDR	R0, =0x8C
	B	_BranchGlobalHandler
USB_LP_CAN_RX0_IRQHandler:	
	LDR	R0, =0x90
	B	_BranchGlobalHandler
CAN_RX1_IRQHandler:	
	LDR	R0, =0x94
	B	_BranchGlobalHandler
CAN_SCE_IRQHandler:	
	LDR	R0, =0x98
	B	_BranchGlobalHandler
EXTI9_5_IRQHandler:	
	LDR	R0, =0x9C
	B	_BranchGlobalHandler
TIM1_BRK_IRQHandler:	
	LDR	R0, =0xA0
	B	_BranchGlobalHandler
TIM1_UP_IRQHandler:	
	LDR	R0, =0xA4
	B	_BranchGlobalHandler
TIM1_TRG_COM_IRQHandler:	
	LDR	R0, =0xA8
	B	_BranchGlobalHandler
TIM1_CC_IRQHandler:	
	LDR	R0, =0xAC
	B	_BranchGlobalHandler
TIM2_IRQHandler:	
	LDR	R0, =0xB0
	B	_BranchGlobalHandler
TIM3_IRQHandler:	
	LDR	R0, =0xB4
	B	_BranchGlobalHandler
TIM4_IRQHandler:	
	LDR	R0, =0xB8
	B	_BranchGlobalHandler
I2C1_EV_IRQHandler:	
	LDR	R0, =0xBC
	B	_BranchGlobalHandler
I2C1_ER_IRQHandler:	
	LDR	R0, =0xC0
	B	_BranchGlobalHandler
I2C2_EV_IRQHandler:	
	LDR	R0, =0xC4
	B	_BranchGlobalHandler
I2C2_ER_IRQHandler:	
	LDR	R0, =0xC8
	B	_BranchGlobalHandler
SPI1_IRQHandler:	
	LDR	R0, =0xCC
	B	_BranchGlobalHandler
SPI2_IRQHandler:	
	LDR	R0, =0xD0
	B	_BranchGlobalHandler
USART1_IRQHandler:
	# registerszɃWX^obNAbv
	LDR	R1, =registers
	# X^bNɑޔꂽ
	# r0,r1,r2,r3,r12,LR,PC,xPSR
	# registersɕۑ
	LDR	R0, [SP, #0x0]
	STR	R0, [R1, #0x0]
	LDR	R0, [SP, #0x4]
	STR	R0, [R1, #0x4]
	LDR	R0, [SP, #0x8]
	STR	R0, [R1, #0x8]
	LDR	R0, [SP, #0xC]
	STR	R0, [R1, #0xC]
	LDR	R0, [SP, #0x10]
	STR	R0, [R1, #0x30]
	LDR	R0, [SP, #0x14]
	STR	R0, [R1, #0x38]
	LDR	R0, [SP, #0x18]
	STR	R0, [R1, #0x3C]
	LDR	R0, [SP, #0x1C]
	STR	R0, [R1, #0x44]
	#c̃WX^ۑ
	STR	R4, [R1, #0x10]
	STR	R5, [R1, #0x14]
	STR	R6, [R1, #0x18]
	STR	R7, [R1, #0x1C]
	MOV	R0, R8
	STR	R0, [R1, #0x20]
	MOV	R0, R9
	STR	R0, [R1, #0x24]
	MOV	R0, R10
	STR	R0, [R1, #0x28]
	MOV	R0, R11
	STR	R0, [R1, #0x2C]
	MOV	R0, R12
	STR	R0, [R1, #0x30]
	SUB	R0, R0, #0x20
	MOV	R0, SP
	STR	R0, [R1, #0x34]
	
	LDR	R0, =0xD4
	B	_int_func
USART2_IRQHandler:	
	LDR	R0, =0xD8
	B	_BranchGlobalHandler
USART3_IRQHandler:	
	LDR	R0, =0xDC
	B	_BranchGlobalHandler
EXTI15_10_IRQHandler:	
	LDR	R0, =0xE0
	B	_BranchGlobalHandler
RTCAlarm_IRQHandler:	
	LDR	R0, =0xE4
	B	_BranchGlobalHandler
USBWakeUp_IRQHandler:	
	LDR	R0, =0xE8
	B	_BranchGlobalHandler

_BranchGlobalHandler:	
	LDR	R1, =0x02000000
	LDR	R0, [R0, R1]
	BX	R0
	